{Model, ObjectId, Inflector} = require 'bongo'

Relationship = require './relationship'

module.exports = class Module extends Model
  
  @attachInterface =(verb, noun, isPlural, doLowercaseFirst, fn)->
    [fn, doLowercaseFirst] = [doLowercaseFirst, fn] unless fn
    doLowercaseFirst or= yes
    noun = Inflector.pluralize noun if isPlural
    name = Inflector.camelize "#{verb}_#{noun}", doLowercaseFirst
    @::[name] = fn
    @
  
  @setRelationships = (relationships)->
    constructor = @
    if 'function' is typeof relationships
      relationships = relationships.call constructor
    constructor.relationships = relationships
    for own name, def of relationships
      constructor
        .attachInterface('add', name, no, getAdder_ constructor, name, def)
        .attachInterface('fetch', name, yes, getFetcher_ constructor, name, def)
    return
  
  getFetcher_ =(constructor, name, def)->
    ->
      model = @
      switch arguments.length
        when 1
          [callback] = arguments
        when 2
          [selector, callback] = arguments
        when 3
          [selector, options, callback] = arguments
      selector or= {}
      selector.as =
        if 'string' is typeof def.as
          def.as
        else
          $in: def.as
      orientation =
        if def.targetType?
          selector.targetName = def.targetType.name
          selector.sourceName = constructor.name
          selector.sourceId   = model._id
          'target'
        else if def.sourceType?
          selector.sourceName = def.sourceType.name
          selector.targetName = constructor.name
          selector.targetId   = model._id
          'source'
        else
          throw new Error 'Invalid relationship'
      otherConstructor = def["#{orientation}Type"]
      idField = "#{orientation}Id"
      fields = {}
      fields[idField] = yes
      Relationship.someData selector, fields, (err, cursor)->
        callback err if err
        cursor.toArray (err, docs)->
          ids = (rel[idField] for rel in docs)
          otherConstructor.all _id: $in: ids, (err, cursor)->
            callback? err, cursor
            return
          return
        return
      return

  getAdder_ =(constructor, name, def)->
    (target, as, callback)->
      [callback, as] = [as, callback] unless callback
      {targetType, as} = def
      unless target.constructor is targetType
        throw new TypeError 'Type mismatch'
      new Relationship({
        targetId    : target._id
        targetName  : targetType.name 
        sourceId    : @_id
        sourceName  : constructor.name
        as
      }).save callback
      return
  #
  #fetchSources:(selector, options, callback)->
  #  selector.targetName = @constructor.name
  #  selector.sourceName = options.type.name
  #  fetchOthers_ selector, options, callback
  #  
  #fetchTargets:(selector, options, callback)->
  #  selector.sourceName = @constructor.name
  #  selector.targetName = options.type.name
  #  fetchOthers_ selector, options, callback
  #  
  #fetchOthers_ =->
  #